import { HttpHeaders, HttpParams } from '@angular/common/http';
export declare const enum FileError {
    NumError = 0,
    TypeError = 1,
    SizeError = 2
}
export declare const enum UploadStatus {
    Uploading = 0,
    Completed = 1,
    UploadError = 2,
    FileNumError = 3
}
export interface UploadObject {
    url: string;
    files: File | File[] | Blob | Blob[];
    fields?: any;
    filesKey?: string | string[];
    process?: boolean;
    headers?: {
        [name: string]: string | string[];
    } | HttpHeaders;
    params?: {
        [name: string]: string | string[];
    } | HttpParams;
    responseType?: 'arraybuffer' | 'blob' | 'json' | 'text';
    withCredentials?: boolean;
    method?: string;
}
export interface UploadEvent {
    status: UploadStatus;
    percent: number;
    data?: any;
}
export interface FileOption {
    size?: {
        min?: number;
        max?: number;
    };
    skipInvalid?: boolean;
}
